Atooms
======

[![pypi](https://img.shields.io/pypi/v/atooms.svg)](https://pypi.python.org/pypi/atooms/)
[![version](https://img.shields.io/pypi/pyversions/atooms.svg)](https://pypi.python.org/pypi/atooms/)
[![license](https://img.shields.io/pypi/l/atooms.svg)](https://en.wikipedia.org/wiki/GNU_General_Public_License)
[![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/git/https%3A%2F%2Fframagit.org%2Fatooms%2Fatooms/HEAD?labpath=docs%2F)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.1183301.svg)](https://doi.org/10.5281/zenodo.1183301)
[![pipeline](https://framagit.org/atooms/atooms/badges/master/pipeline.svg)](https://framagit.org/atooms/atooms/badges/master/pipeline.svg)
[![coverage report](https://framagit.org/atooms/atooms/badges/master/coverage.svg)](https://framagit.org/atooms/atooms/-/commits/master)

**atooms** is a high-level Python framework for simulations of interacting particles, such as molecular dynamics or Monte Carlo.

This is the core package: it provides a consistent interface to the basic objects of particle-based simulations. [Feature packages](Feature packages) are built on top of it and implement complex simulation methods and analysis tools.

Quick start
-----------

Here is a small example for setting up a mixture of two types of particles, A and B, in a periodic elongated cell. The number density is set to unity.
```python
from atooms.system import System

system = System(N=64)
system.replicate(times=4, axis=0)
system.composition = {'A': 128, 'B': 128}
system.density = 1.0
```

Particles in the central part of the cell get a random displacement and are folded back into the simulation cell
```python
import numpy

for p in system.particle:
    if abs(p.position[0]) < system.cell.side[0] / 4:
        p.position += 0.5 * (numpy.random.random() - 0.5)
        p.fold(system.cell)
system.show('ovito')
```

![](https://framagit.org/atooms/atooms/-/raw/master/snapshot.png)

Simulation data are stored in trajectory files, which are easy to manipulate and convert with atooms. Here, we write the system species and positions in a single-frame trajectory file using the [xyz format](https://en.wikipedia.org/wiki/XYZ_format).
```python
from atooms.trajectory import TrajectoryXYZ

with TrajectoryXYZ('input.xyz', 'w') as th:
    th.variables = ['species', 'position']  # actually, this is the default
    th.write(system)
```

The trajectory file can now be used to start a simulation using one the available [simulation backends](https://atooms.frama.io/atooms/tutorial/simulations.html) or your own code.

Features
--------

- Focus on a simple and expressive interface
- API refined over the years towards consistency
- Modular and extensible design via namespace packages
- Semantic versioning - for what is worth
- Easy to interface: in-house codes and custom formats are first-class citizens
- Support for efficient simulation backends, with a focus on GPU codes

Documentation
-------------
Check out the [tutorial](https://atooms.frama.io/docs/) for more examples and the [public API](https://atooms.frama.io/atooms/) for more details.

Org-mode and jupyter notebooks are available under [docs](https://framagit.org/atooms/atooms/-/blob/master/docs/). You can run them interactively on [Binder](https://mybinder.org/v2/git/https%3A%2F%2Fframagit.org%2Fatooms%2Fatooms/HEAD?labpath=docs%2).

Installation
------------
From the python package index
```
pip install atooms
```

From the code repository
```
git clone https://framagit.org/atooms/atooms.git
cd atooms
make install
```

Contributing
------------
You are welcome to contribute to this project! Please have a look at [these guidelines](https://framagit.org/atooms/atooms/-/blob/master/CONTRIBUTING.md).

Feature packages 
------------------
Atooms is modular: it is easy to add new functionalities, and just those you actually need.

Feature packages are available from the [atooms main repository](https://framagit.org/atooms). They are installed in the `atooms` namespace to prevent name clashing. If you want to add your own feature package to the atooms namespace, structure it this way
```bash
atooms/your_package
atooms/your_package/__init__.py
```

where ```__init__.py``` contains

```python
from pkgutil import extend_path
__path__ = extend_path(__path__, __name__)
```

Install `your_package` and you are ready to go
```python
import atooms.your_package
```

Authors
-------
Daniele Coslovich: https://www.units.it/daniele.coslovich/

Thanks go to Francesco Turci, Geert Kapteijns and Romain Simon for their contributions.

module potential

  implicit none

  integer, private, parameter :: dp = selected_real_kind(12)
  real(dp), allocatable :: epsilon_(:,:)
  real(dp), allocatable :: kappa_(:,:)
  real(dp), allocatable :: sigma_(:,:)

contains

  subroutine init(epsilon, kappa, sigma)
    double precision, intent(in) :: epsilon(:,:), kappa(:,:), sigma(:,:)
    if (allocated(epsilon_).and.allocated(sigma_).and.allocated(kappa_)) return
    allocate(epsilon_(size(epsilon,1),size(epsilon,2)), source=epsilon)
    allocate(kappa_(size(kappa,1),size(kappa,2)), source=kappa)
    allocate(sigma_(size(sigma,1),size(sigma,2)), source=sigma)
  end subroutine init
  
  subroutine compute(isp,jsp,rsq,u,w,h)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: u, w, h
    double precision                :: sigsq, r
    r = SQRT(rsq)
    u = epsilon_(isp,jsp) / (kappa_(isp,jsp) * r) * EXP(kappa_(isp,jsp) * (sigma_(isp,jsp) - r))
    w = (1 / r) * (1 / r + kappa_(isp,jsp)) * u
    h = u / r**4 + (2 / r**2 + kappa_(isp,jsp) / r) * w
  end subroutine compute

end module potential

 module neighbor_list

  ! use helpers
  
  implicit none

contains

  pure subroutine pbc(r,box,hbox)
    double precision, intent(inout) :: r(:)
    double precision, intent(in)    :: box(:), hbox(:)
    where (abs(r) > hbox)
       r = r - sign(box,r)
    end where
  end subroutine pbc

  pure subroutine distance(i,j,pos,rij)
    integer, intent(in) :: i, j
    double precision, intent(in)    :: pos(:,:)
    double precision, intent(inout) :: rij(:)
    rij = pos(:,i) - pos(:,j)
  end subroutine distance

  pure subroutine dot(r1,r2,out)
    double precision, intent(in)  :: r1(:), r2(:)
    double precision, intent(out) :: out
    out = dot_product(r1,r2)
  end subroutine dot

  subroutine zero(x)
    double precision, intent(inout)  :: x(:,:)
    !$omp parallel workshare
    x = 0.d0
    !$omp end parallel workshare
  end subroutine zero

  subroutine compute(box,pos,ids,rcut,neighbors,number_neighbors,distances,error)
    !! Compute neighbor lists using III Newton law
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:), rcut(:,:)
    integer,          intent(in)    :: ids(:)
    integer,          intent(inout) :: neighbors(:,:), number_neighbors(size(pos,2))
    double precision, intent(inout) :: distances(size(neighbors,1), size(neighbors,2))
    logical,          intent(out)   :: error
    double precision                :: rij(size(pos,1)), rijsq, hbox(size(pos,1))
    integer                         :: i, j, isp, jsp
    error = .false.
    hbox = box / 2
    !$omp parallel default(private) firstprivate(rcut) shared(pos,ids,box,hbox,neighbors,number_neighbors,distances,error)
    !$omp do schedule(runtime)
    do i = 1,size(pos,2)
       number_neighbors(i) = 0
       isp = ids(i)
       do j = i+1,size(pos,2)
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          if (rijsq <= rcut(isp,jsp)**2) then
             number_neighbors(i) = number_neighbors(i) + 1
             if (number_neighbors(i) <= size(neighbors,1)) then
                neighbors(number_neighbors(i),i) = j
                distances(number_neighbors(i),i) = rijsq
             else
                error = .true.
             end if
          end if
       end do
    end do
    !$omp end parallel
  end subroutine compute

  subroutine compute_from_neighbors(box,pos,ids,rcut,inp_neighbors,inp_number_neighbors,neighbors,number_neighbors,distances,error)
    !! Compute neighbor lists using III Newton law
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:), rcut(:,:)
    integer,          intent(in)    :: ids(:)
    integer,          intent(in)    :: inp_neighbors(:,:), inp_number_neighbors(size(pos,2))
    integer,          intent(inout) :: neighbors(:,:), number_neighbors(size(pos,2))
    double precision, intent(inout) :: distances(size(neighbors,1), size(neighbors,2))
    logical,          intent(out)   :: error
    double precision                :: rij(size(pos,1)), rijsq, hbox(size(pos,1))
    integer                         :: i, j, jn, isp, jsp
    error = .false.
    hbox = box / 2
    !$omp parallel default(private) firstprivate(rcut) shared(pos,ids,box,hbox,neighbors,number_neighbors,distances,error)
    !$omp do schedule(runtime)
    do i = 1,size(pos,2)
       number_neighbors(i) = 0
       isp = ids(i)
       do jn = 1,inp_number_neighbors(i)
          j = inp_neighbors(jn,i)
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          if (rijsq <= rcut(isp,jsp)**2) then
             number_neighbors(i) = number_neighbors(i) + 1
             if (number_neighbors(i) <= size(neighbors,1)) then
                neighbors(number_neighbors(i),i) = j
                distances(number_neighbors(i),i) = rijsq
             else
                error = .true.
             end if
          end if
       end do
    end do
    !$omp end parallel
  end subroutine compute_from_neighbors
  
  subroutine compute_full(box,pos,ids,rcut,neighbors,number_neighbors,distances,error)
    !! Compute full neighbor lists without assuming III Newton law will be used
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:), rcut(:,:)
    integer,          intent(in)    :: ids(:)
    integer,          intent(inout) :: neighbors(:,:), number_neighbors(size(pos,2))
    double precision, intent(inout) :: distances(size(neighbors,1), size(neighbors,2))
    logical,          intent(out)   :: error
    double precision                :: rij(size(pos,1)), rijsq, hbox(size(pos,1))
    integer                         :: i, j, isp, jsp
    error = .false.
    hbox = box / 2
    number_neighbors(:) = 0
    ! TODO: add openmp parallel
    do i = 1,size(pos,2)
       isp = ids(i)
       do j = i+1,size(pos,2)
          if (i==j) cycle
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          if (rijsq <= rcut(isp,jsp)**2) then
             number_neighbors(i) = number_neighbors(i) + 1
             number_neighbors(j) = number_neighbors(j) + 1
             if (number_neighbors(i) <= size(neighbors,1)) then
                neighbors(number_neighbors(i),i) = j
                distances(number_neighbors(i),i) = rijsq
             else
                error = .true.
             end if
             if (number_neighbors(j) <= size(neighbors,1)) then
                neighbors(number_neighbors(j),j) = i
                distances(number_neighbors(j),j) = rijsq
             else
                error = .true.
             end if
          end if
       end do
    end do
  end subroutine compute_full

  ! Solid-angle nearest neighbors (SANN), cf. van Meel, Filion, Valeriani and Frenkel (2011)
  ! Adapted from partycls, by Joris Paret
  SUBROUTINE compute_sann(box, pos, ids, rcutoff, neighbors, number_neighbors, distances, error)
    ! Parameters
    REAL(8), INTENT(in)     :: pos(:,:) ! position of i and all other particles
    REAL(8), INTENT(in)     :: rcutoff ! cutoff distance to identify all potential neighbours 
    REAL(8), INTENT(in)     :: box(:) ! edge of the simulation box  
    INTEGER :: ids(:)
    !INTEGER(8), INTENT(out) :: selectedneighbors(500) ! list of selected neighbours in group = 1
    integer,  intent(inout) :: neighbors(:,:), number_neighbors(size(pos,2))
    real(8), intent(inout) :: distances(size(neighbors,1), size(neighbors,2))
    logical,          intent(out)   :: error
    ! Variables
    INTEGER :: i, j, k, m ! m = tentative number of neighbours
    INTEGER :: np ! total number of particles, particles in group=1
    INTEGER :: countneighbors ! countneighbors = number of neighbours of particle i
    INTEGER :: neighbor(500) ! list of neighbours of particles i
    INTEGER :: sortneighbor(500) ! sorted 
    INTEGER :: Nb ! final number of neighbours of particle i
    INTEGER :: idx_j ! index of particle j
    REAL(8)    :: distance(500) ! distance = list of distances between each 
    REAL(8)    :: distancesorted(500) ! distancesorted = sorted distances       
    REAL(8)    :: rm, rm1 ! R(m) as in Eq.3 in the manuscript
    REAL(8)    :: r_ij(SIZE(box)) ! vector between i and j
    REAL(8)    :: rcutoff_sq, d_ij ! distance between particle i and particle j
    ! Computation
    error = .false.
    rcutoff_sq = rcutoff**2
    DO i = 1,SIZE(pos, 2)
       countneighbors = 0
       ! *** STEP 1 ***
       ! first we identify the particles within a cutoff radius rcutoff
       ! loop over all particles different from i
       DO j = 1,SIZE(pos, 2)
          IF (i == j) cycle
          r_ij(:) =  pos(:,j) - pos(:,i)
          CALL pbc(r_ij, box, box/2)
          d_ij = SUM(r_ij**2)
          ! identify neighbours that are within a cutoff (rcutoff)
          IF (d_ij < rcutoff_sq) THEN
             ! j is a neighbour of i
             countneighbors = countneighbors + 1
             ! build a list of neighbours
             neighbor(countneighbors) = j 
             ! create a list with the distance between i and j 
             distance(countneighbors) = d_ij
          END IF
       END DO

       ! *** STEP 2 ***
       ! sort all (countneighbors)
       ! neighbours (neighbor) according to their 
       ! distances (distance) and create  a new list of 
       ! particle i's (sortneighbor)
       ! and a new sorted list of distances (distancesorted)
       m = countneighbors
       !CALL insertion_sort_inplace(neighbor(1:m), distance(1:m))  !, sortneighbor(1:m), distancesorted(1:m))
       !sortneighbor(1:m) = neighbor(1:m)
       !distancesorted(1:m) = distance(1:m)
       CALL insertion_sort(neighbor(1:m), distance(1:m), sortneighbor(1:m), distancesorted(1:m))
       !do k=1,m
       !   if (i==1) print*, k, sortneighbor(k), distancesorted(k)
       !end do
       ! *** STEP 3 *** 
       ! start with 3 neighbours
       m = 3
       ! *** STEP 4 ***
       ! compute R(m) as in Eq.3 
       rm = 0
       DO k=1,m
          rm = rm + distancesorted(k)
       END DO
       rm = rm/(m-2)
       ! compute r(m+1)
       ! coslo: this fixes the issue that m can get larger than number of neighbors (by 2 units)
       !DO j = 1,countneighbors
       DO j = 1,countneighbors-3
          rm1 = 0
          DO k=1,m
             rm1 = rm1 + distancesorted(k)
          END DO
          rm1 = rm1/(m-2)
          ! *** STEP 5 ***  
          ! if rm > rm1     
          IF (rm >= rm1) THEN     
             rm = rm1
             ! increase m
             m = m+1
          ELSE
             ! *** STEP 6 ***
             ! if rm < rm1, m is the final number of neighbours
             ! coslo: this fixes an issue with SANN when the potential list is larger than m
             m = m - 1
             EXIT
          END IF
       END DO
       ! the final number of neighbours is m = Nb(i) 
       ! and the neighbours are  selectedneighbors
       number_neighbors(i) = m
       if (m <= size(neighbors, 1)) then
          neighbors(1:m, i) = sortneighbor(1:m)
          distances(1:m, i) = distancesorted(1:m)
          !do k = 1,m
          !   if(i==1) print*, k, neighbors(k,i), distancesorted(k), '*'
          !end do
       else
          error = .true.
       end if
    END DO
  END SUBROUTINE compute_sann

 subroutine insertion_sort(n, x, ns, xs)
    implicit none
    integer, intent(inout) :: n(:)
    real(8), intent(inout) :: x(:)
    integer, intent(out) :: ns(size(n))
    real(8), intent(out) :: xs(size(n))
    integer :: i,j
    integer :: temp
    real(8) :: temp_x
    ns = n
    xs = x
    do i=2,size(ns)
       temp=ns(i)
       temp_x=xs(i)
       do j=i-1,1,-1
          if (xs(j) <= temp_x) exit
          ns(j+1)=ns(j)
          xs(j+1)=xs(j)
       enddo
       ns(j+1)=temp
       xs(j+1)=temp_x
    enddo
  end subroutine insertion_sort

 subroutine insertion_sort_inplace(n, x)
    implicit none
    integer, intent(inout) :: n(:)
    real(8), intent(inout) :: x(:)
    integer :: i,j
    integer :: temp
    real(8) :: temp_x
    do i=2,size(n)
       temp=n(i)
       temp_x=x(i)
       do j=i-1,1,-1
          if (x(j) <= temp_x) exit
          n(j+1)=n(j)
          x(j+1)=x(j)
       enddo
       n(j+1)=temp
       x(j+1)=temp_x
    enddo
  end subroutine insertion_sort_inplace
  
  SUBROUTINE sort(neighbor, distance, sortneighbor, distancesorted)
    ! Parameters
    INTEGER, INTENT(inout) :: neighbor(:)
    REAL(8), INTENT(inout) :: distance(size(neighbor))
    INTEGER, INTENT(out) :: sortneighbor(size(neighbor))
    REAL(8), INTENT(out) :: distancesorted(size(neighbor))
    ! Variables
    INTEGER :: i, imin, j, n_tmp
    REAL(8)    :: d_tmp
    ! Computation
    DO i=1,size(neighbor)
      imin = i
      DO j=i+1,size(neighbor)
        IF (distance(j) < distance(imin)) THEN
          imin = j
        END IF
        d_tmp = distance(i)
        n_tmp = neighbor(i)
        distance(i) = distance(imin)
        neighbor(i) = neighbor(imin)
        distance(imin) = d_tmp
        neighbor(imin) = n_tmp
        distancesorted(i) = distance(i)
        sortneighbor(i) = neighbor(i)
        ! print*, sortneighbor(1:i)
     END DO
     if (i == size(neighbor)) sortneighbor(i) = neighbor(i)
     if (i == size(neighbor)) distancesorted(i) = distance(i)
     !print*, 'sort', i, imin, neighbor(i), sortneighbor(i)
    END DO
  END SUBROUTINE   
  
  logical function need_update_largest(displacement, skin)
    !! Update is needed if the largest displacement exceeds 1/2
    !! of the Verlet skin (from Allen & Tildesley)
    real(8), intent(in) :: displacement(:,:), skin
    real(8) :: dr(size(displacement,2)), dr_max, dr_tmp
    integer ::i
    dr_max = 0.d0
    !$omp parallel do private(dr_tmp) schedule(static) reduction(max:dr_max)
    do i = 1,size(displacement,2)
       dr_tmp = dot_product(displacement(:,i),displacement(:,i))
       if (dr_tmp > dr_max) dr_max = dr_tmp
    end do
    need_update_largest = dr_max > (skin / 2)**2
  end function need_update_largest

  subroutine add_displacement(pos,pos_old,box,displacement)
    !! Add displacements of particles for a subset of particles specified by index.
    !! Assume that PBC has been applied, hence we need to refold them.
    real(8), intent(in)    :: pos(:,:)
    real(8), intent(inout) :: pos_old(:,:), displacement(:,:)
    real(8), intent(in)    :: box(:)
    real(8) :: hbox(size(box))
    integer :: i
    hbox = box / 2
    !$omp parallel do schedule(static)
    do i = 1,size(pos,2)
       displacement(:,i) = displacement(:,i) + pos(:,i) - pos_old(:,i)
       call pbc(displacement(:,i),box,hbox)
       pos_old(:,i) = pos(:,i)
    end do
  end subroutine add_displacement
  
end module neighbor_list

module potential

  implicit none

  double precision, allocatable :: epsilon_(:,:)
  double precision, allocatable :: sigma_(:,:)
  double precision, allocatable :: A_(:,:)
  double precision, allocatable :: B_(:,:)
  integer :: exponent_

contains

  subroutine init(exponent, epsilon, sigma, A, B)
    integer, intent(in) :: exponent
    double precision, intent(in) :: epsilon(:,:), sigma(:,:), A(:,:), B(:,:)
    if (allocated(epsilon_).and.allocated(sigma_).and.allocated(A_).and.allocated(B_)) return
    ! only works with recent compilers...
    !allocate(exponent_, source=exponent)
    !allocate(epsilon_, source=epsilon)
    !allocate(sigma_, source=sigma)
    exponent_ = exponent
    allocate(epsilon_(size(epsilon,1),size(epsilon,2)), source=epsilon)
    allocate(sigma_(size(sigma,1),size(sigma,2)), source=sigma)
    allocate(A_(size(A,1),size(A,2)), source=A)
    allocate(B_(size(B,1),size(B,2)), source=B)
  end subroutine init
  
  subroutine compute(isp,jsp,rsq,u,w,h)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: u, w, h
    double precision :: exp_term, der_term, der2_term, r, u_0
    r = rsq**0.5
    exp_term = exp(A_(isp,jsp) / (r-B_(isp,jsp)))
    der_term = A_(isp,jsp) / (r-B_(isp,jsp))**2
    der2_term = A_(isp,jsp) / (r-B_(isp,jsp))**3
    u_0 = epsilon_(isp,jsp) * (sigma_(isp,jsp) / r)**exponent_
    u = u_0 * exp_term
    w = (exponent_ * u_0 / rsq + u_0 / r * der_term) * exp_term
    h = (+ exponent_ * (exponent_+2) / rsq**2 &
         + exponent_ / r**3 * der_term &
         + (exponent_+1) / r**3 * der_term &
         + 1.d0 / rsq * 2 * der2_term &
         + 1.d0 / rsq * der_term**2) * u_0 * exp_term

  end subroutine compute

end module potential

module potential

  implicit none

  double precision, allocatable :: epsilon_(:,:)
  double precision, allocatable :: sigma_(:,:)
  integer :: exponent_

contains

  subroutine init(exponent, epsilon, sigma)
    integer, intent(in) :: exponent
    double precision, intent(in) :: epsilon(:,:), sigma(:,:)
    if (allocated(epsilon_).and.allocated(sigma_)) return
    exponent_ = exponent
    allocate(epsilon_(size(epsilon,1),size(epsilon,2)), source=epsilon)
    allocate(sigma_(size(sigma,1),size(sigma,2)), source=sigma)
  end subroutine init
  
  subroutine compute(isp,jsp,rsq,u,w,h)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: u, w, h
    u = epsilon_(isp,jsp) * (sigma_(isp,jsp)**2 / rsq)**(exponent_/2)
    w = exponent_ * u / rsq
    h = exponent_ * (exponent_+2) * u / (rsq**2)
  end subroutine compute

  ! subroutine compute_vector(isp,jsp,rsq,u,w,h)
  !   integer,          intent(in)    :: isp, jsp(:)
  !   double precision, intent(in)    :: rsq(:)
  !   double precision, intent(inout) :: u(:), w(:), h(:)
  !   double precision                :: eps(size(rsq)), sig2(size(rsq))
  !   integer                         :: i
  !   eps = [(epsilon_(isp, jsp(i)), i=1,size(rsq))]
  !   sig2 = [(sigma_(isp, jsp(i))**2, i=1,size(rsq))]
  !   u = eps * (sig2 / rsq)**(exponent_/2)
  !   w = exponent_ * u / rsq
  !   h = exponent_ * (exponent_+2) * u / (rsq**2)
  ! end subroutine compute_vector
  
end module potential

module cutoff

  use potential, init_potential => init
  
  implicit none

  double precision, allocatable :: rcut_(:,:)
  double precision, allocatable :: ucut(:,:)

contains

  subroutine init(rcut)
    double precision, intent(in) :: rcut(:,:)
    if (allocated(rcut_)) return
    allocate(rcut_(size(rcut,1),size(rcut,2)), source=rcut)
    call adjust()
  end subroutine init

  subroutine adjust()
    integer :: isp,jsp,nsp
    double precision :: rcutsq, u, w, h
    if (allocated(ucut)) return
    nsp = size(rcut_,1)
    allocate(ucut(nsp,nsp))
    do isp = 1,nsp
       do jsp = 1,nsp
          rcutsq = rcut_(isp,jsp)**2
          call compute(isp,jsp,rcutsq,ucut(isp,jsp),w,h)
       end do
    end do
  end subroutine adjust

  subroutine is_zero(isp,jsp,rsq,result)
    integer,          intent(in) :: isp, jsp
    double precision, intent(in) :: rsq
    logical,          intent(out) :: result
    result = rsq > rcut_(isp,jsp)**2
  end subroutine is_zero
  
  subroutine smooth(isp,jsp,rsq,uij,wij,hij)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: uij,wij,hij
    uij = uij - ucut(isp,jsp)
    wij = wij
    hij = hij
  end subroutine smooth

  ! subroutine smooth_vector(isp,jsp,rsq,uij,wij,hij)
  !   integer,          intent(in)    :: isp, jsp(:)
  !   double precision, intent(in)    :: rsq(:)
  !   double precision, intent(inout) :: uij(:),wij(:),hij(:)
  !   integer                         :: i
  !   do i = 1,size(uij)
  !      uij(i) = uij(i) - ucut(isp,jsp(i))
  !   end do
  !   !uij = [(uij(i) - ucut(isp,jsp(i)), i=1,size(uij))]
  !   wij = wij
  !   hij = hij
  ! end subroutine smooth_vector
  
end module cutoff

 
module interaction

  use helpers
  use cutoff  !, only: is_zero, smooth, adjust
  use potential  !, only: compute
  
  implicit none

contains

  subroutine energies(zero,box,pos,ids,rad,epot)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    double precision, intent(inout) :: epot(:)
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: i, j, isp, jsp
    logical                         :: zero_ij
    if (zero) then
       !$omp parallel workshare
       epot = 0.0d0
       !$omp end parallel workshare
    end if
    hbox = box / 2
    ! it is crucial to use default(firstprivate) otherwise the shared module-level variables of cutoffs and potentials are not copied!
    !$omp parallel default(firstprivate) shared(pos,ids,box,hbox,epot)
    !$omp do schedule(runtime) reduction(+:epot)
    do i = 1,size(pos,2)
       isp = ids(i)
       do j = i+1,size(pos,2)
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          call is_zero(isp,jsp,rijsq,zero_ij)
          if (.not.zero_ij) then
             call compute(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             call smooth(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             epot(i) = epot(i) + uij
             epot(j) = epot(j) + uij
          end if
       end do
    end do
    !$omp end parallel
  end subroutine energies

  subroutine forces(zero,box,pos,ids,rad,for,epot,virial)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    double precision, intent(inout) :: for(:,:)
    double precision, intent(inout) :: epot, virial  ! inout to allow in place modification
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: i, j, isp, jsp
    logical                         :: zero_ij
    ! TODO: it should be possible to adjust the cutoff from python, but the compute interface is not parsed correctly
    if (zero) then
       !$omp parallel workshare
       for = 0.0d0
       !$omp end parallel workshare
       epot = 0.0d0
       virial = 0.0d0
    end if
    hbox = box / 2
    !omp parallel do private(isp,jsp,rij,rijsq,zero_ij,uij,wij) schedule(runtime) reduction(+:epot,virial,for)
    ! it is crucial to use default(firstprivate) otherwise the shared module-level variables of cutoffs and potentials are not copied!
    !$omp parallel default(firstprivate) shared(pos,ids,box,hbox,epot,virial,for)
    !$omp do schedule(runtime) reduction(+:epot,virial,for)
    do i = 1,size(pos,2)
       isp = ids(i)
       do j = i+1,size(pos,2)
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          call is_zero(isp,jsp,rijsq,zero_ij)
          if (.not.zero_ij) then
             ! TODO: remove hij via interface             
             call compute(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             call smooth(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             !print*, isp, jsp, rijsq**0.5, uij, wij
             epot = epot + uij
             virial = virial + wij * rijsq
             for(:,i) = for(:,i) + wij * rij
             for(:,j) = for(:,j) - wij * rij
          end if
       end do
    end do
    !$omp end parallel
  end subroutine forces
  
  subroutine hessian(zero,box,pos,ids,rad,hes)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    !double precision, intent(inout) :: hes(size(pos,1),size(pos,2),size(pos,1),size(pos,2))
    double precision, intent(inout) :: hes(:,:,:,:)
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, wwij, hbox(size(pos,1))
    double precision                :: unity(size(pos,1),size(pos,1)), mij(size(pos,1),size(pos,1)), mmij(size(pos,1),size(pos,1))
    integer                         :: i, j, isp, jsp
    logical                         :: zero_ij
    if (zero) hes = 0.0d0
    unity = 0.0d0
    hbox = box / 2
    do i = 1,size(unity,1)
       unity(i,i) = 1.0d0
    end do
    loop_i: do i = 1,size(pos,2)
       isp = ids(i)
       loop_j: do j = i+1,size(pos,2)          
          jsp = ids(j)
          rij = pos(:,i) - pos(:,j)
          call pbc(rij,box,hbox)
          rijsq = dot_product(rij,rij)
          call is_zero(isp,jsp,rijsq,zero_ij)
          if (.not.zero_ij) then
             call compute(isp,jsp,rijsq,uij,wij,wwij)
             call smooth(isp,jsp,rijsq,uij,wij,wwij)
             mij = unity(:,:) * wij
             mmij = outer_product(rij,rij) * wwij
             ! Diagonal in i,j - diagonal in x,y
             hes(:,i,:,i) = hes(:,i,:,i) - mij
             hes(:,j,:,j) = hes(:,j,:,j) - mij
             ! Off-diagonal in i,j - diagonal in x,y
             hes(:,i,:,j) = hes(:,i,:,j) + mij
             hes(:,j,:,i) = hes(:,j,:,i) + mij
             ! Diagonal in i,j - off-diagonal in x,y
             hes(:,i,:,i) = hes(:,i,:,i) + mmij
             hes(:,j,:,j) = hes(:,j,:,j) + mmij
             ! Off-diagonal in i,j - off-diagonal in x,y
             hes(:,i,:,j) = hes(:,i,:,j) - mmij
             hes(:,j,:,i) = hes(:,j,:,i) - mmij
          end if
       end do loop_j
    end do loop_i
  end subroutine hessian

  subroutine gradw(zero,box,pos,ids,rad,grad_w)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,  intent(in)            :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    double precision, intent(inout) :: grad_w(:,:)
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, wwij
    double precision                :: hbox(size(pos,1)), grwij(size(pos,1)), forc(size(pos,1),size(pos,2)), epot, virial
    integer                         :: i, j, isp, jsp
    logical                         :: zero_ij
    call forces(.TRUE.,box,pos,ids,rad,forc,epot,virial)
    if (zero) grad_w = 0.d0
    hbox = box / 2
    loop_i: do i = 1,size(pos,2)
       isp = ids(i)
       loop_j: do j = i+1,size(pos,2)          
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          call is_zero(isp,jsp,rijsq,zero_ij)          
          if (.not.zero_ij) then
             call compute(isp,jsp,rijsq,uij,wij,wwij)
             call smooth(isp,jsp,rijsq,uij,wij,wwij)
             ! Signs are reversed compared to f90atooms...
             grwij = wij * forc(:,i) - rij(:) * (wwij * DOT_PRODUCT(rij(:),forc(:,i)))
             grad_w(:,i) = grad_w(:,i) + grwij(:)
             grad_w(:,j) = grad_w(:,j) - grwij(:)
             grwij = wij * forc(:,j) - rij(:) * (wwij * DOT_PRODUCT(rij(:),forc(:,j)))
             grad_w(:,i) = grad_w(:,i) - grwij(:)
             grad_w(:,j) = grad_w(:,j) + grwij(:)
          end if
       end do loop_j
    end do loop_i
    grad_w = grad_w * 2
  end subroutine gradw
  
end module interaction

module interaction_neighbors

  use helpers
  use cutoff  !, only: is_zero, smooth, adjust
  use potential  !, only: compute
  
  implicit none

contains

  subroutine energies(zero,box,pos,ids,rad,neighbors,number_neighbors,epot)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    integer,          intent(in)    :: neighbors(:,:), number_neighbors(:)
    double precision, intent(inout) :: epot(:)
    double precision                :: rij(size(pos,1)), rijsq, uij, hbox(size(pos,1)), hij, wij
    integer                         :: i, j, isp, jsp, jn
    logical                         :: zero_ij
    if (zero) then
       !$omp parallel workshare
       epot = 0.0d0
       !$omp end parallel workshare
    end if
    hbox = box / 2
    ! it is crucial to use default(firstprivate) otherwise the shared module-level variables of cutoffs and potentials are not copied!
    !$omp parallel default(firstprivate) shared(pos,ids,box,hbox,epot)
    !$omp do schedule(runtime) reduction(+:epot)
    do i = 1,size(pos,2)
       isp = ids(i)
       do jn = 1,number_neighbors(i)
          j = neighbors(jn,i)
          !if (newton) then
          !   if (j<i) cycle
          !end if
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          call is_zero(isp,jsp,rijsq,zero_ij)          
          if (.not.zero_ij) then
             ! TODO: remove hij via interface             
             call compute(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             call smooth(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             epot(i) = epot(i) + uij
             epot(j) = epot(j) + uij
          end if
       end do
    end do
    !$omp end parallel
  end subroutine energies

  subroutine forces(zero,box,pos,ids,rad,neighbors,number_neighbors,for,epot,virial)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    integer,          intent(in)    :: neighbors(:,:), number_neighbors(:)
    double precision, intent(inout) :: for(:,:)
    double precision, intent(inout) :: epot, virial
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: i, j, isp, jsp, jn
    logical                         :: zero_ij
    ! TODO: it should be possible to adjust the cutoff from python, but the compute interface is not parsed correctly
    if (zero) then
       !$omp parallel workshare
       for = 0.0d0
       !$omp end parallel workshare
       epot = 0.0d0
       virial = 0.0d0
    end if
    hbox = box / 2
    ! it is crucial to use default(firstprivate) otherwise the shared module-level variables of cutoffs and potentials are not copied!
    !$omp parallel default(firstprivate) shared(pos,ids,box,hbox,epot,virial,for)
    !$omp do schedule(runtime) reduction(+:epot,virial,for)
    do i = 1,size(pos,2)
       isp = ids(i)
       do jn = 1,number_neighbors(i)
          j = neighbors(jn,i)
          !if (newton) then
          !   if (j<i) cycle
          !end if
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          call is_zero(isp,jsp,rijsq,zero_ij)          
          if (.not.zero_ij) then
             ! TODO: remove hij via interface             
             call compute(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             call smooth(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             !print*, isp, jsp, rijsq**0.5, uij, wij
             epot = epot + uij
             virial = virial + wij * rijsq
             for(:,i) = for(:,i) + wij * rij
             for(:,j) = for(:,j) - wij * rij
          end if
       end do
    end do
    !$omp end parallel
  end subroutine forces
  
  subroutine hessian(zero,box,pos,ids,rad,neighbors,number_neighbors,hes)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    integer,          intent(in)    :: neighbors(:,:), number_neighbors(:)
    !double precision, intent(inout) :: hes(size(pos,1),size(pos,2),size(pos,1),size(pos,2))
    double precision, intent(inout) :: hes(:,:,:,:)
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, wwij, hbox(size(pos,1))
    double precision                :: unity(size(pos,1),size(pos,1)), mij(size(pos,1),size(pos,1)), mmij(size(pos,1),size(pos,1))
    integer                         :: i, j, isp, jsp, jn
    logical                         :: zero_ij
    if (zero) hes = 0.0d0
    unity = 0.0d0
    hbox = box / 2
    do i = 1,size(unity,1)
       unity(i,i) = 1.0d0
    end do
    loop_i: do i = 1,size(pos,2)
       isp = ids(i)
       loop_j: do jn = 1,number_neighbors(i)
          j = neighbors(jn,i)
          jsp = ids(j)
          rij = pos(:,i) - pos(:,j)
          call pbc(rij,box,hbox)
          rijsq = dot_product(rij,rij)
          call is_zero(isp,jsp,rijsq,zero_ij)
          if (.not.zero_ij) then
             call compute(isp,jsp,rijsq,uij,wij,wwij)
             call smooth(isp,jsp,rijsq,uij,wij,wwij)
             mij = unity(:,:) * wij
             mmij = outer_product(rij,rij) * wwij
             ! Diagonal in i,j - diagonal in x,y
             hes(:,i,:,i) = hes(:,i,:,i) - mij
             hes(:,j,:,j) = hes(:,j,:,j) - mij
             ! Off-diagonal in i,j - diagonal in x,y
             hes(:,i,:,j) = hes(:,i,:,j) + mij
             hes(:,j,:,i) = hes(:,j,:,i) + mij
             ! Diagonal in i,j - off-diagonal in x,y
             hes(:,i,:,i) = hes(:,i,:,i) + mmij
             hes(:,j,:,j) = hes(:,j,:,j) + mmij
             ! Off-diagonal in i,j - off-diagonal in x,y
             hes(:,i,:,j) = hes(:,i,:,j) - mmij
             hes(:,j,:,i) = hes(:,j,:,i) - mmij
          end if
       end do loop_j
    end do loop_i
  end subroutine hessian

end module interaction_neighbors

module interaction_polydisperse

  use helpers
  use cutoff  !, only: is_zero, smooth, adjust
  use potential  !, only: compute
  
  implicit none

contains

  subroutine forces(zero,box,pos,ids,rad,for,epot,virial)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)
    double precision, intent(inout) :: for(:,:)
    double precision, intent(inout) :: epot, virial
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: i, j, isp, jsp
    logical                         :: zero_ij
    ! TODO: it should be possible to adjust the cutoff from python, but the compute interface is not parsed correctly
    if (zero) then
       !$omp parallel workshare
       for = 0.0d0
       !$omp end parallel workshare
       epot = 0.0d0
       virial = 0.0d0
    end if
    hbox = box / 2
    !omp parallel do private(isp,jsp,rij,rijsq,zero_ij,uij,wij) schedule(runtime) reduction(+:epot,virial,for)
    ! it is crucial to use default(firstprivate) otherwise the shared module-level variables of cutoffs and potentials are not copied!
    !$omp parallel default(firstprivate) shared(pos,ids,box,hbox,epot,virial,for)
    !$omp do schedule(runtime) reduction(+:epot,virial,for)
    do i = 1,size(pos,2)
       isp = ids(i)
       do j = i+1,size(pos,2)
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          rijsq = rijsq / (rad(i)+rad(j))**2
          call is_zero(isp,jsp,rijsq,zero_ij)
          if (.not.zero_ij) then
             ! TODO: remove hij via interface             
             call compute(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             call smooth(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             epot = epot + uij
             ! w = - 1/rad_ij   * du/dr_ij(r_ij/rad_ij) * r_ij
             !   = - 1/rad_ij^2 * du/dr_ij(x) * x^2  with x=r_ij/rad_ij
             ! The scaled rijsq already contains 1/rad_ij^2
             virial = virial + wij * rijsq
             ! We must scale wij for the forces here
             wij = wij / (rad(i)+rad(j))**2
             for(:,i) = for(:,i) + wij * rij
             for(:,j) = for(:,j) - wij * rij
          end if
       end do
    end do
    !$omp end parallel
  end subroutine forces

  subroutine hessian(zero,box,pos,ids,rad,hes)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)
    !double precision, intent(inout) :: hes(size(pos,1),size(pos,2),size(pos,1),size(pos,2))
    double precision, intent(inout) :: hes(:,:,:,:)
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, wwij, hbox(size(pos,1))
    double precision                :: unity(size(pos,1),size(pos,1)), mij(size(pos,1),size(pos,1)), mmij(size(pos,1),size(pos,1))
    integer                         :: i, j, isp, jsp
    logical                         :: zero_ij
    if (zero) hes = 0.0d0
    unity = 0.0d0
    hbox = box / 2
    do i = 1,size(unity,1)
       unity(i,i) = 1.0d0
    end do
    loop_i: do i = 1,size(pos,2)
       isp = ids(i)
       loop_j: do j = i+1,size(pos,2)          
          jsp = ids(j)
          rij = pos(:,i) - pos(:,j)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          rijsq = rijsq / (rad(i)+rad(j))**2
          call is_zero(isp,jsp,rijsq,zero_ij)
          if (.not.zero_ij) then
             call compute(isp,jsp,rijsq,uij,wij,wwij)
             call smooth(isp,jsp,rijsq,uij,wij,wwij)
             wij = wij / (rad(i)+rad(j))**2
             wwij = wwij / (rad(i)+rad(j))**4
             mij = unity(:,:) * wij
             mmij = outer_product(rij,rij) * wwij
             ! Diagonal in i,j - diagonal in x,y
             hes(:,i,:,i) = hes(:,i,:,i) - mij
             hes(:,j,:,j) = hes(:,j,:,j) - mij
             ! Off-diagonal in i,j - diagonal in x,y
             hes(:,i,:,j) = hes(:,i,:,j) + mij
             hes(:,j,:,i) = hes(:,j,:,i) + mij
             ! Diagonal in i,j - off-diagonal in x,y
             hes(:,i,:,i) = hes(:,i,:,i) + mmij
             hes(:,j,:,j) = hes(:,j,:,j) + mmij
             ! Off-diagonal in i,j - off-diagonal in x,y
             hes(:,i,:,j) = hes(:,i,:,j) - mmij
             hes(:,j,:,i) = hes(:,j,:,i) - mmij
          end if
       end do loop_j
    end do loop_i
  end subroutine hessian

  subroutine gradw(zero,box,pos,ids,rad,grad_w)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)
    double precision, intent(inout) :: grad_w(:,:)
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, wwij
    double precision                :: hbox(size(pos,1)), grwij(size(pos,1)), forc(size(pos,1),size(pos,2)), epot, virial
    integer                         :: i, j, isp, jsp
    logical                         :: zero_ij
    call forces(.FALSE.,box,pos,ids,rad,forc,epot,virial)
    if (zero) grad_w = 0.d0
    hbox = box / 2
    loop_i: do i = 1,size(pos,2)
       isp = ids(i)
       loop_j: do j = i+1,size(pos,2)          
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          rijsq = rijsq / (rad(i)+rad(j))**2
          call is_zero(isp,jsp,rijsq,zero_ij)          
          if (.not.zero_ij) then
             call compute(isp,jsp,rijsq,uij,wij,wwij)
             call smooth(isp,jsp,rijsq,uij,wij,wwij)
             wij = wij / (rad(i)+rad(j))**2
             wwij = wwij / (rad(i)+rad(j))**4
             ! Signs are reversed compared to f90atooms...
             grwij = wij * forc(:,i) - rij(:) * (wwij * DOT_PRODUCT(rij(:),forc(:,i)))
             grad_w(:,i) = grad_w(:,i) + grwij(:)
             grad_w(:,j) = grad_w(:,j) - grwij(:)
             grwij = wij * forc(:,j) - rij(:) * (wwij * DOT_PRODUCT(rij(:),forc(:,j)))
             grad_w(:,i) = grad_w(:,i) - grwij(:)
             grad_w(:,j) = grad_w(:,j) + grwij(:)
          end if
       end do loop_j
    end do loop_i
    grad_w = grad_w * 2
  end subroutine gradw
  
end module interaction_polydisperse

module interaction_polydisperse_neighbors

  use helpers
  use cutoff  !, only: is_zero, smooth, adjust
  use potential  !, only: compute
  
  implicit none

contains

  subroutine energies(zero,box,pos,ids,rad,neighbors,number_neighbors,epot)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    integer,          intent(in)    :: neighbors(:,:), number_neighbors(:)
    double precision, intent(inout) :: epot(:)
    double precision                :: rij(size(pos,1)), rijsq, uij, hbox(size(pos,1)), hij, wij
    integer                         :: i, j, isp, jsp, jn
    logical                         :: zero_ij
    if (zero) then
       !$omp parallel workshare
       epot = 0.0d0
       !$omp end parallel workshare
    end if
    hbox = box / 2
    ! it is crucial to use default(firstprivate) otherwise the shared module-level variables of cutoffs and potentials are not copied!
    !$omp parallel default(firstprivate) shared(pos,ids,box,hbox,epot)
    !$omp do schedule(runtime) reduction(+:epot)
    do i = 1,size(pos,2)
       isp = ids(i)
       do jn = 1,number_neighbors(i)
          j = neighbors(jn,i)
          !if (newton) then
          !   if (j<i) cycle
          !end if
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          rijsq = rijsq / (rad(i)+rad(j))**2
          call is_zero(isp,jsp,rijsq,zero_ij)          
          if (.not.zero_ij) then
             ! TODO: remove hij via interface             
             call compute(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             call smooth(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             epot(i) = epot(i) + uij
             epot(j) = epot(j) + uij
          end if
       end do
    end do
    !$omp end parallel
  end subroutine energies

  subroutine forces(zero,box,pos,ids,rad,neighbors,number_neighbors,for,epot,virial)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    integer,          intent(in)    :: neighbors(:,:), number_neighbors(:)
    double precision, intent(inout) :: for(:,:)
    double precision, intent(inout) :: epot, virial
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: i, j, isp, jsp, jn
    logical                         :: zero_ij
    ! TODO: it should be possible to adjust the cutoff from python, but the compute interface is not parsed correctly
    if (zero) then
       !$omp parallel workshare
       for = 0.0d0
       !$omp end parallel workshare
       epot = 0.0d0
       virial = 0.0d0
    end if
    hbox = box / 2
    ! it is crucial to use default(firstprivate) otherwise the shared module-level variables of cutoffs and potentials are not copied!
    !$omp parallel default(firstprivate) shared(pos,ids,rad,box,hbox,epot,virial,for)
    !$omp do schedule(runtime) reduction(+:epot,virial,for)
    do i = 1,size(pos,2)
       isp = ids(i)
       do jn = 1,number_neighbors(i)
          j = neighbors(jn,i)
          !if (newton) then
          !   if (j<i) cycle
          !end if
          jsp = ids(j)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          rijsq = rijsq / (rad(i)+rad(j))**2
          call is_zero(isp,jsp,rijsq,zero_ij)          
          if (.not.zero_ij) then
             ! TODO: remove hij via interface             
             call compute(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             call smooth(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
             !print*, isp, jsp, rijsq**0.5, uij, wij
             epot = epot + uij
             ! The scaled rijsq already contains 1/rad_ij^2
             virial = virial + wij * rijsq
             ! We must scale wij for the forces here
             wij = wij / (rad(i)+rad(j))**2
             for(:,i) = for(:,i) + wij * rij
             for(:,j) = for(:,j) - wij * rij
          end if
       end do
    end do
    !$omp end parallel
  end subroutine forces
  
  subroutine hessian(zero,box,pos,ids,rad,neighbors,number_neighbors,hes)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)  ! not used here
    integer,          intent(in)    :: neighbors(:,:), number_neighbors(:)
    !double precision, intent(inout) :: hes(size(pos,1),size(pos,2),size(pos,1),size(pos,2))
    double precision, intent(inout) :: hes(:,:,:,:)
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, wwij, hbox(size(pos,1))
    double precision                :: unity(size(pos,1),size(pos,1)), mij(size(pos,1),size(pos,1)), mmij(size(pos,1),size(pos,1))
    integer                         :: i, j, isp, jsp, jn
    logical                         :: zero_ij
    if (zero) hes = 0.0d0
    unity = 0.0d0
    hbox = box / 2
    do i = 1,size(unity,1)
       unity(i,i) = 1.0d0
    end do
    loop_i: do i = 1,size(pos,2)
       isp = ids(i)
       loop_j: do jn = 1,number_neighbors(i)
          j = neighbors(jn,i)
          jsp = ids(j)
          rij = pos(:,i) - pos(:,j)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          rijsq = rijsq / (rad(i)+rad(j))**2
          call is_zero(isp,jsp,rijsq,zero_ij)
          if (.not.zero_ij) then
             call compute(isp,jsp,rijsq,uij,wij,wwij)
             call smooth(isp,jsp,rijsq,uij,wij,wwij)
             wij = wij / (rad(i)+rad(j))**2
             wwij = wwij / (rad(i)+rad(j))**4
             mij = unity(:,:) * wij
             mmij = outer_product(rij,rij) * wwij
             ! Diagonal in i,j - diagonal in x,y
             hes(:,i,:,i) = hes(:,i,:,i) - mij
             hes(:,j,:,j) = hes(:,j,:,j) - mij
             ! Off-diagonal in i,j - diagonal in x,y
             hes(:,i,:,j) = hes(:,i,:,j) + mij
             hes(:,j,:,i) = hes(:,j,:,i) + mij
             ! Diagonal in i,j - off-diagonal in x,y
             hes(:,i,:,i) = hes(:,i,:,i) + mmij
             hes(:,j,:,j) = hes(:,j,:,j) + mmij
             ! Off-diagonal in i,j - off-diagonal in x,y
             hes(:,i,:,j) = hes(:,i,:,j) - mmij
             hes(:,j,:,i) = hes(:,j,:,i) - mmij
          end if
       end do loop_j
    end do loop_i
  end subroutine hessian

end module interaction_polydisperse_neighbors

module cutoff

  implicit none

  integer, private, parameter :: dp = selected_real_kind(12)
  double precision, allocatable :: rcut_(:,:)

contains

  subroutine init(rcut)
    double precision, intent(in) :: rcut(:,:)
    if (allocated(rcut_)) return
    allocate(rcut_(size(rcut,1),size(rcut,2)), source=rcut)
  end subroutine init
  
  subroutine is_zero(isp,jsp,rsq,result)
    integer,          intent(in) :: isp, jsp
    double precision, intent(in) :: rsq
    logical,          intent(out) :: result
    result = rsq >= rcut_(isp,jsp)**2
  end subroutine is_zero
    
  subroutine smooth(isp,jsp,rsq,uij,wij,hij)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: uij,wij,hij
  end subroutine smooth
  
end module cutoff

module potential

  implicit none

  double precision, allocatable :: epsilon_(:,:)
  double precision, allocatable :: sigma_(:,:)

contains

  subroutine init(epsilon, sigma)
    double precision, intent(in) :: epsilon(:,:), sigma(:,:)
    if (allocated(epsilon_).and.allocated(sigma_)) return
    allocate(epsilon_(size(epsilon,1),size(epsilon,2)), source=epsilon)
    allocate(sigma_(size(sigma,1),size(sigma,2)), source=sigma)
  end subroutine init
  
  subroutine compute(isp,jsp,rsq,u,w,h)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: u, w, h
    u = epsilon_(isp,jsp) * exp(- rsq / sigma_(isp,jsp)**2)
    w = 2 * u
    h = 4 * u
  end subroutine compute

end module potential

module potential

  implicit none

  double precision, allocatable :: epsilon_(:,:,:)
  double precision, allocatable :: sigma_(:,:,:)
  integer, allocatable :: exponent_(:)
  integer :: order_

contains

  subroutine init(exponent, epsilon, sigma)
    integer, intent(in) :: exponent(:)
    double precision, intent(in) :: epsilon(:,:,:), sigma(:,:,:)
    if (allocated(epsilon_).and.allocated(sigma_)) return
    allocate(exponent_(size(exponent)), source=exponent)
    allocate(epsilon_(size(epsilon,1),size(epsilon,2),size(epsilon,3)), source=epsilon)
    allocate(sigma_(size(sigma,1),size(sigma,2),size(sigma,3)), source=sigma)
    order_ = size(exponent_)
  end subroutine init
  
  subroutine compute(isp,jsp,rsq,u,w,h)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: u, w, h
    double precision                :: utmp
    integer                         :: i, order
    u = 0.d0
    w = 0.d0
    h = 0.d0
    do i = 1,order_
       ! Need to keep utmp local to each power with this recursive expression
       utmp = epsilon_(isp,jsp,i) * (sigma_(isp,jsp,i)**2 / rsq) ** (exponent_(i)/2)
       u = u + utmp
       w = w + exponent_(i) * utmp / rsq
       h = h + exponent_(i) * (exponent_(i)+2) * utmp / (rsq**2)
    end do
  end subroutine compute

end module potential

module interaction

  use helpers
  use cutoff  !, only: is_zero, smooth, adjust
  use potential  !, only: compute
  
  implicit none

contains

  subroutine forces(box,pos,ids,bonds,for,epot,virial)
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    integer,          intent(in)    :: bonds(:,:)
    double precision, intent(inout) :: for(:,:)
    double precision, intent(out)   :: epot, virial
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: b, i, j, isp, jsp
    !$omp parallel workshare
    for = 0.0d0
    !$omp end parallel workshare
    epot = 0.0d0
    virial = 0.0d0
    hbox = box / 2
    !$omp parallel default(firstprivate) shared(pos,ids,box,hbox,epot,virial,for)
    !$omp do schedule(runtime) reduction(+:epot,virial,for)
    do b = 1,size(bonds,2)
       i = bonds(1,b)
       j = bonds(2,b)
       isp = ids(i)
       jsp = ids(j)
       call distance(i,j,pos,rij)
       call pbc(rij,box,hbox)
       call dot(rij,rij,rijsq)
       call compute(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
       epot = epot + uij
       virial = virial + wij * rijsq
       for(:,i) = for(:,i) + wij * rij
       for(:,j) = for(:,j) - wij * rij
    end do
    !$omp end parallel
  end subroutine forces
  
end module interaction

module interaction_test
  use interaction, only: forces_inter => forces
  use bond_term, only: forces_intra => forces
contains
  subroutine forces(zero,box,pos,spe,mol,rad,bond,bond_type,for,epot,virial)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:), pos(:,:), rad(:)
    integer,          intent(in)    :: spe(:), bond(:,:), bond_type(:)
    integer,          intent(in)    :: mol(:)  ! molecule to which particle belongs
    double precision, intent(inout) :: for(:,:)
    double precision, intent(inout) :: epot, virial
    call forces_inter(zero,box,pos,spe,rad,mol,for,epot,virial)
    call forces_intra(.false.,box,pos,spe,mol,rad,bond,bond_type,for,epot,virial)
  end subroutine forces
end module interaction_test

module cutoff

  use potential, init_potential => init
  
  implicit none

  double precision, allocatable :: rspl_(:,:)
  double precision, allocatable :: rcut_(:,:)
  double precision, allocatable :: acut(:,:)
  double precision, allocatable :: ccut(:,:)

contains

  subroutine init(rspl)
    double precision, intent(in) :: rspl(:,:)
    if (allocated(rspl_)) return
    allocate(rspl_(size(rspl,1),size(rspl,2)), source=rspl)
    call adjust()
  end subroutine init

  subroutine adjust()
    integer :: isp,jsp,nsp
    double precision :: rsplsq, u, w, h, u1, u2
    nsp = size(rspl_,1)
    if (allocated(rcut_)) return; allocate(rcut_(nsp,nsp))
    if (allocated(acut)) return; allocate(acut(nsp,nsp))
    if (allocated(ccut)) return; allocate(ccut(nsp,nsp))
    do isp = 1,nsp
       do jsp = 1,nsp
          rsplsq = rspl_(isp,jsp)**2
          call compute(isp,jsp,rsplsq,u,w,h)
          ! the potential is cubic-splined between rspl < r < rcut 
          ! cubic-splined cutoff : u(r) = A*(B-r)^3 + C for rspl < r < rcut=B
          ! where 
          !   A = - u2^2/(12*u1)
          !   B = rspl - 2*(u1/u2) = rcut
          !   C = u0 + (2*u1^2)/(3*u2)
          ! with u0=u(rspl), u1=u'(rspl), u2=u''(rspl)
          u2 = h * rspl_(isp,jsp)**2 - w ! second order derivative
          u1 = - w * rspl_(isp,jsp)      ! first order derivative
          ccut(isp,jsp) = - u + (2*u1**2) / (3*u2)          
          acut(isp,jsp) = - u2**2 / (12*u1)
          rcut_(isp,jsp) = rspl_(isp,jsp) - (2*u1/u2)
       end do
    end do
  end subroutine adjust

  subroutine is_zero(isp,jsp,rsq,result)
    integer,          intent(in) :: isp, jsp
    double precision, intent(in) :: rsq
    logical,          intent(out) :: result
    result = rsq > rcut_(isp,jsp)**2
  end subroutine is_zero
  
  subroutine smooth(isp,jsp,rsq,uij,wij,hij)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq  ! unused
    double precision, intent(inout) :: uij,wij,hij
    double precision :: rij, dr
    ! Cubic splined between rspl and rcut :
    ! function is overwritten when between rspl and rcut
    uij = uij + ccut(isp,jsp)
    if (rsq > rspl_(isp,jsp)**2) then
       rij = sqrt(rsq)
       dr  = rcut_(isp,jsp) - rij
       uij = acut(isp,jsp) * dr**3 
       wij = 3.0d0 * acut(isp,jsp) * dr**2 / rij
       ! remember : hij = wij / r^2 + V'' / r^2
       hij = wij / rsq + 6.0d0 * acut(isp,jsp) * dr / rsq
    end if
  end subroutine smooth
  
end module cutoff

module angle_potential

  implicit none

  double precision, allocatable :: theta0_(:,:,:)
  double precision, allocatable :: K_(:,:,:)

contains

  subroutine init(theta0, K)
    double precision, intent(in) :: theta0(:,:,:), K(:,:,:)
    if (allocated(theta0_).and.allocated(K_)) return
    allocate(theta0_(size(theta0,1),size(theta0,2),size(theta0,3)), source=theta0)
    allocate(K_(size(K,1),size(K,2),size(K,3)), source=K)
  end subroutine init
  
  subroutine compute_angle(isp,jsp,ksp,rsq_ij,rsq_ik,rsq_jk,cos_theta_ijk,u,w,h)
    integer,          intent(in)    :: isp, jsp, ksp
    double precision, intent(in)    :: rsq_ij, rsq_ik, rsq_jk, cos_theta_ijk
    double precision, intent(inout) :: u, w, h
    double precision :: r, theta
    theta = acos(cos_theta_ijk)
    u = 0.5d0 * K_(isp,jsp,ksp) * (theta - theta0_(isp,jsp,ksp))**2
    w = K_(isp,jsp,ksp) * (theta - theta0_(isp,jsp,ksp))
    h = 0.0
  end subroutine compute_angle
  
end module angle_potential

module cutoff

  use potential, init_potential => init
  
  implicit none

  double precision, allocatable :: rcut_(:,:)
  double precision, allocatable :: a_cut(:,:)
  double precision, allocatable :: b_cut(:,:)

contains

  subroutine init(rcut)
    double precision, intent(in) :: rcut(:,:)
    if (allocated(rcut_)) return
    allocate(rcut_(size(rcut,1),size(rcut,2)), source=rcut)
    call adjust()
  end subroutine init

  subroutine adjust()
    ! note that U'=-u1*radius 
    !   A = - 0.5*U'(r_c)/r_c
    !   B =   0.5*U'(r_c)*r_c - U(r_c) 
    ! so that
    !   U_qs(r) = U(r) + A*r^2 + B
    ! is smooth up to its first derivative at r=r_c
    integer :: isp,jsp,nsp
    double precision :: rcutsq, u, w, h
    if (allocated(a_cut)) return
    allocate(a_cut(size(rcut_,1),size(rcut_,2)))
    allocate(b_cut(size(rcut_,1),size(rcut_,2)))
    nsp = size(rcut_,1)
    do isp = 1,nsp
       do jsp = 1,nsp
          rcutsq = rcut_(isp,jsp)**2
          call compute(isp,jsp,rcutsq,u,w,h)
          a_cut(isp,jsp) =   0.5d0 * w
          b_cut(isp,jsp) = - 0.5d0 * w * rcutsq - u
       end do
    end do
  end subroutine adjust

  subroutine is_zero(isp,jsp,rsq,result)
    integer,          intent(in) :: isp, jsp
    double precision, intent(in) :: rsq
    logical,          intent(out) :: result
    result = rsq > rcut_(isp,jsp)**2
  end subroutine is_zero
  
  subroutine smooth(isp,jsp,rsq,uij,wij,hij)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: uij,wij,hij
    uij = uij + a_cut(isp,jsp) * rsq + b_cut(isp,jsp)
    wij = wij - a_cut(isp,jsp) * 2.d0
    hij = hij
  end subroutine smooth
  
end module cutoff

module potential

  implicit none

  integer, private, parameter :: dp = selected_real_kind(12)
  real(dp), allocatable :: epsilon_(:,:)
  real(dp), allocatable :: sigma_(:,:)

contains

  subroutine init(epsilon, sigma)
    double precision, intent(in) :: epsilon(:,:), sigma(:,:)
    if (allocated(epsilon_).and.allocated(sigma_)) return
    allocate(epsilon_(size(epsilon,1),size(epsilon,2)), source=epsilon)
    allocate(sigma_(size(sigma,1),size(sigma,2)), source=sigma)
  end subroutine init
  
  subroutine compute(isp,jsp,rsq,u,w,h)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: u, w, h
    double precision                :: sigsq
    sigsq = sigma_(isp,jsp)**2
    u = 4 * epsilon_(isp,jsp) * ((sigsq/rsq)**6 - (sigsq/rsq)**3)
    w = 24 * epsilon_(isp,jsp) * (2*(sigsq/rsq)**6 - (sigsq/rsq)**3) / rsq
    h = 96 * epsilon_(isp,jsp) * (7*(sigsq/rsq)**6 - 2*(sigsq/rsq)**3) / rsq**2
  end subroutine compute

end module potential

 
module two_body

  use helpers
  use cutoff  !, only: is_zero, smooth, adjust
  use potential  !, only: compute
  
  implicit none

contains

  subroutine forces(box,pos,ids,terms,for,epot,virial)
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    integer,          intent(in)    :: terms(:,:)
    double precision, intent(inout) :: for(:,:)
    double precision, intent(out)   :: epot, virial
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: i, j, isp, jsp
    logical                         :: zero_ij
    ! TODO: it should be possible to adjust the cutoff from python, but the compute interface is not parsed correctly
    call adjust(compute)
    for = 0.0d0
    epot = 0.0d0
    virial = 0.0d0
    hbox = box / 2
    do ii = 1,size(terms,2)
       i = terms(1,ii)
       j = terms(2,ii)
       isp = ids(i)
       jsp = ids(j)
       call distance(i,j,pos,rij)
       call pbc(rij,box,hbox)
       call dot(rij,rij,rijsq)
       call compute_stretch(isp,jsp,ksp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
       epot = epot + uij
       virial = virial + wij * rijsq
       for(:,i) = for(:,i) + wij * rij
       for(:,j) = for(:,j) - wij * rij
    end do
  end subroutine forces
  
end module two_body

module interaction_intramolecular

  use helpers
  use bond_potential  !, only: compute
  
  implicit none

contains

  subroutine zeroing(for, epot, virial)
    double precision, intent(inout) :: for(:,:)
    double precision, intent(inout) :: epot, virial
    !$omp parallel workshare
    for = 0.0d0
    !$omp end parallel workshare
    epot = 0.0d0
    virial = 0.0d0    
  end subroutine zeroing
  
  subroutine forces_bond(zero,box,pos,spe,mol,rad,bond,bond_type,for,epot,virial)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:), pos(:,:), rad(:)
    integer,          intent(in)    :: spe(:), bond(:,:), bond_type(:)
    integer,          intent(in)    :: mol(:)  ! molecule to which particle belongs
    double precision, intent(inout) :: for(:,:)
    double precision, intent(inout) :: epot, virial
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: ii, i, j, isp, jsp
    if (zero) then
       call zeroing(for, epot, virial)
    end if
    hbox = box / 2
    do ii = 1,size(bond,2)
       !print*, ii, size(bond,1), size(bond,2)
       i = bond(1,ii)
       j = bond(2,ii)
       isp = spe(mol(i))  ! species of the molecule to which particle i belongs
       jsp = bond_type(ii)
       call distance(i,j,pos,rij)
       call pbc(rij,box,hbox)
       call dot(rij,rij,rijsq)
       !call compute_stretch(isp,jsp,ksp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
       call compute_bond(isp,jsp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
       epot = epot + uij
       virial = virial + wij * rijsq
       for(:,i) = for(:,i) + wij * rij
       for(:,j) = for(:,j) - wij * rij
    end do
  end subroutine forces_bond

  ! subroutine forces_angle(zero,box,pos,spe,mol,rad,angle,angle_type,for,epot,virial)
  !   logical,          intent(in)    :: zero ! to set variables to zero
  !   double precision, intent(in)    :: box(:), pos(:,:), rad(:)
  !   integer,          intent(in)    :: spe(:), angle(:,:,:), angle_type(:)
  !   integer,          intent(in)    :: mol(:)  ! molecule to which particle belongs
  !   double precision, intent(inout) :: for(:,:)
  !   double precision, intent(inout) :: epot, virial
  !   double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
  !   integer                         :: ii, i, j, k, isp, jsp
  !   call zeroing(for, epot, virial)
  !   hbox = box / 2
  !   do ii = 1,size(angle,2)
  !      i = angle(1,ii)
  !      j = angle(2,ii)
  !      k = angle(3,ii)
  !      isp = spe(mol(i))  ! species of the molecule to which particle i belongs
  !      jsp = bond_type(ii)
  !      call distance(i,j,pos,rij)
  !      call pbc(rij,box,hbox)
  !      call dot(rij,rij,rijsq)
  !      !
  !      !call compute_angle(isp,jsp,ksp,rijsq,..........,uij,wij,hij) ! wij = -(du/dr)/r
  !      !
  !      epot = epot + uij
  !      virial = virial + wij * rijsq
  !      for(:,i) = for(:,i) + wij * rij
  !      for(:,j) = for(:,j) - wij * rij
  !   end do
  ! end subroutine forces_angle
  
end module interaction_intramolecular

module helpers
  
  implicit none

contains

  pure subroutine pbc(r,box,hbox)
    double precision, intent(inout) :: r(:)
    double precision, intent(in)    :: box(:), hbox(:)
    where (abs(r) > hbox)
       r = r - sign(box,r)
    end where
  end subroutine pbc

  pure subroutine distance(i,j,pos,rij)
    integer, intent(in) :: i, j
    double precision, intent(in)    :: pos(:,:)
    double precision, intent(inout) :: rij(:)
    rij = pos(:,i) - pos(:,j)
  end subroutine distance

  pure subroutine dot(r1,r2,out)
    double precision, intent(in)  :: r1(:), r2(:)
    double precision, intent(out) :: out
    out = dot_product(r1,r2)
  end subroutine dot
  
  pure function outer_product(x,y) result (out)
    double precision, intent(in) :: x(:), y(:)
    double precision :: out(size(x),size(x))
    integer :: i, j
    do i = 1,size(x)
       do j = 1,size(x)
          out(i,j) = x(i) * y(j)
       end do
    end do
  end function outer_product

end module helpers

module potential

  implicit none

  double precision, allocatable :: epsilon_(:,:)
  double precision, allocatable :: sigma_(:,:)
  double precision, allocatable :: R0_(:,:)
  double precision, allocatable :: K_(:,:)

contains

  subroutine init(exponent, epsilon, sigma)
    integer, intent(in) :: exponent
    double precision, intent(in) :: epsilon(:,:), sigma(:,:)
    if (allocated(epsilon_).and.allocated(sigma_)) return
    exponent_ = exponent
    allocate(epsilon_(size(epsilon,1),size(epsilon,2)), source=epsilon)
    allocate(sigma_(size(sigma,1),size(sigma,2)), source=sigma)
  end subroutine init
  
  subroutine compute(isp,jsp,rsq,u,w,h)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: u, w, h
    u = - K_(isp,jsp) * R0_(isp,jsp)**2 * log(1 - (rsq / sigma_(isp,jsp)**2))
    w = - K_(isp,jsp) * R0_(isp,jsp)**2 / sigma_(isp,jsp)**2 / (1 - (rsq / sigma_(isp,jsp)**2)
    h = 0.0
    if (rsq < 2**(1./6)) then
       sigsq = sigma_(isp,jsp)**2
       u = u + 4 * epsilon_(isp,jsp) * ((sigsq/rsq)**6 - (sigsq/rsq)**3) + epsilon_(isp,jsp)
       w = w + 24 * epsilon_(isp,jsp) * (2*(sigsq/rsq)**6 - (sigsq/rsq)**3) / rsq
       h = h + 96 * epsilon_(isp,jsp) * (7*(sigsq/rsq)**6 - 2*(sigsq/rsq)**3) / rsq**2
    end if
  end subroutine compute
  
end module potential

module helpers
  
  implicit none

contains

  pure subroutine pbc(r,box,hbox)
    double precision, intent(inout) :: r(:)
    double precision, intent(in)    :: box(:), hbox(:)
    if (abs(r(1)) > hbox(1)) r(1) = r(1) - sign(box(1),r(1))
    if (abs(r(2)) > hbox(2)) r(2) = r(2) - sign(box(2),r(2))
    if (abs(r(3)) > hbox(3)) r(3) = r(3) - sign(box(3),r(3))
  end subroutine pbc

  pure subroutine dot(r1,r2,out)
    double precision, intent(in)  :: r1(:), r2(:)
    double precision, intent(out) :: out
    out = r1(1)*r2(1) + r1(2)*r2(2) + r1(3)*r2(3)
  end subroutine dot

  pure subroutine distance(i,j,pos,rij)
    integer, intent(in) :: i, j
    double precision, intent(in)    :: pos(:,:)
    double precision, intent(inout) :: rij(:)
    rij(1) = pos(1,i) - pos(1,j)
    rij(2) = pos(2,i) - pos(2,j)
    rij(3) = pos(3,i) - pos(3,j)
  end subroutine distance

  pure function outer_product(x,y) result (out)
    double precision, intent(in) :: x(:), y(:)
    double precision :: out(size(x),size(x))
    integer :: i, j
    do i = 1,size(x)
       do j = 1,size(x)
          out(i,j) = x(i) * y(j)
       end do
    end do
  end function outer_product

end module helpers

module bond_potential

  implicit none

  integer, private, parameter :: dp = selected_real_kind(12)
  real(dp), allocatable :: epsilon_(:,:)
  real(dp), allocatable :: sigma_(:,:)

contains

  subroutine init(epsilon, sigma)
    double precision, intent(in) :: epsilon(:,:), sigma(:,:)
    if (allocated(epsilon_).and.allocated(sigma_)) return
    allocate(epsilon_(size(epsilon,1),size(epsilon,2)), source=epsilon)
    allocate(sigma_(size(sigma,1),size(sigma,2)), source=sigma)
  end subroutine init
  
  subroutine compute_bond(isp,jsp,rsq,u,w,h)
    integer,          intent(in)    :: isp, jsp
    double precision, intent(in)    :: rsq
    double precision, intent(inout) :: u, w, h
    double precision                :: sigsq, r
    r = SQRT(rsq)
    u = 0.5d0 * epsilon_(isp,jsp) * (1.d0 - r/sigma_(isp,jsp))**2
    w = epsilon_(isp,jsp) * (1.d0 - r/sigma_(isp,jsp)) / (sigma_(isp,jsp) * r)
    h = epsilon_(isp,jsp) / (sigma_(isp,jsp) * rsq * r)
  end subroutine compute_bond

end module bond_potential

 
module interaction

  use helpers
  use cutoff  !, only: is_zero, smooth, adjust
  use potential  !, only: compute
  
  implicit none

contains

  subroutine forces(zero,box,pos,ids,rad,for,epot,virial)
    logical,          intent(in)    :: zero ! to set variables to zero
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    double precision, intent(in)    :: rad(:)
    double precision, intent(inout) :: for(:,:)
    double precision, intent(inout) :: epot, virial
    double precision                :: rij(size(pos,1)), rijsq
    double precision                :: rik(size(pos,1)), riksq
    double precision                :: rjk(size(pos,1)), rjksq
    double precision                :: uijk, wijk, hbox(size(pos,1)), hijk, cos_theta_ijk
    double precision                :: aijk, aij, aik, sin_theta_ijk
    integer                         :: i, j, jj, k, isp, jsp, jjsp, ksp
    logical                         :: zero_ij, zero_ik, zero_jk
    double precision, parameter :: SMALL = 1e-10
    ! TODO: it should be possible to adjust the cutoff from python, but the compute interface is not parsed correctly
    !call adjust(compute)
    for = 0.0d0
    epot = 0.0d0
    virial = 0.0d0
    hbox = box / 2
    do j = 1,size(pos,2)
       do i = j+1,size(pos,2)
       !do j = 1,size(pos,2)
          jsp = ids(j)
          isp = ids(i)
          call distance(i,j,pos,rij)
          call pbc(rij,box,hbox)
          call dot(rij,rij,rijsq)
          call is_zero(isp,jsp,rijsq,zero_ij)
          do k = i+1,size(pos,2)
             ksp = ids(k)
             call distance(i,k,pos,rik)             
             jj = j  ! This is a hack to make inline work
             call distance(jj,k,pos,rjk)
             call pbc(rik,box,hbox)
             call pbc(rjk,box,hbox)
             call dot(rik,rik,riksq)
             call dot(rjk,rjk,rjksq)
             call is_zero(isp,ksp,riksq,zero_ik)
             jjsp = jsp  ! This is a hack to make inline work
             call is_zero(jjsp,ksp,rjksq,zero_jk)
             if (.not.zero_ij .and. .not.zero_ik .and. .not.zero_jk) then
                cos_theta_ijk = dot_product(rij,rik) / sqrt(rijsq * riksq)
                sin_theta_ijk = sqrt(1 - cos_theta_ijk**2) 
                if (sin_theta_ijk < SMALL) sin_theta_ijk = SMALL
                ! s = 1.0/s;
                ! TODO: remove hij via interface             
                !call compute_three_body(isp,jsp,ksp,rijsq,riksq,cos_theta_ijk,uijk,wijk,hijk) ! wij = -(du/dr)/r
                !call smooth_three_body(isp,jsp,ksp,rijsq,uij,wij,hij) ! wij = -(du/dr)/r
                call compute(isp,jsp,ksp,rijsq,riksq,rjksq,cos_theta_ijk,uijk,wijk,hijk) 
                ! call smooth(isp,jsp,ksp,rijsq,uijk,wijk,hijk) ! wij = -(du/dr)/r
                epot = epot + uijk
                print*, i, j, k, uijk, acos(cos_theta_ijk) / (3.1415*2) * 360
                wijk = wijk / sin_theta_ijk
                aijk = - 1 / sqrt(rijsq*riksq)
                aij = cos_theta_ijk / rijsq
                aik = cos_theta_ijk / riksq
                for(:,i) = for(:,i) - wijk * (aij*rij + aik*rik + aijk*rij + aijk*rik)
                for(:,j) = for(:,j) + wijk * (aij*rij + aijk*rik)
                for(:,k) = for(:,k) + wijk * (aij*rik + aijk*rij)
                !print*, '----------'
                !print*, for(:,i)
                !print*, for(:,j)
                !print*, for(:,k)

                virial = virial + wijk * rijsq
             end if
          end do
       end do
    end do
    !epot = epot / 2
    !for = for / 2
  end subroutine forces
  
end module interaction

module interaction_neighbors

  use helpers
  use cutoff  !, only: is_zero, smooth, adjust
  use potential  !, only: compute
  
  implicit none

contains

  subroutine forces(box,pos,ids,neighbors,number_neighbors,for,epot,virial)
    double precision, intent(in)    :: box(:)
    double precision, intent(in)    :: pos(:,:)
    integer,          intent(in)    :: ids(:)
    integer,          intent(in)    :: neighbors(:,:), number_neighbors(:)
    double precision, intent(inout) :: for(:,:)
    double precision, intent(out)   :: epot, virial
    double precision                :: rij(size(pos,1)), rijsq, uij, wij, hbox(size(pos,1)), hij
    integer                         :: i, j, isp, jsp, jn, kn, jj, kk
    logical                         :: zero_ij
    for = 0.0d0
    epot = 0.0d0
    virial = 0.0d0
    hbox = box / 2
    do i = 1,size(pos,2)
       isp = ids(i)
       do jn = 1,number_neighbors(i)
          j = neighbors(jn,i)
          jsp = ids(j)
       end do
    end do
  end subroutine forces

end module interaction_neighbors
